//manny0.c--mannies algorithm for pitch-duration random sequence


#include "batonImprov.h"

// definitions
# define DUR 100           //DUR is # of notes in piece
# define TOP 96            //TOP is maximum pitch
# define BOTTOM 24         //BOTTOM is minimum pitch
//housekeeping variables

int xx,yy,jj;

//functions
void randdur(void);
short randpitch(void);
void switchpan(void);


//musicical variables
short pitch;                                       //midi keyno of current note
short pan;                                                  //paning for timbre
short deltapitch;           //interval between current pitch and previous pitch
short intervalseq[20]=
//      {1,2,1,1,2,2,1,0,-100};          //intervalseq is pitch interval sequence
    {1,2,3,4,5,4,3,2,-100};                                // -100 marks end
// durs gives 7 duration patterns; 0 ends pattern; - designates a rest
short durs[7][10]={{16,16,16,0},{8,8,12,0},{4,4,4,0},{4,4,4,4,0},
                {4,4,4,4,4,0},{8,4,4,4,0}, {2,2,2,6,12,2,2,2,0}};
short newdurs;
short tempop,count,repeats=1;
short delta;                                        // up down interval control
short timbreno;
short keyno,play,durpattern,newdurpattern,durindex,durfactor,timb;
long nextnotetime,nextpolltime1,nextpolltime2;


void printline(void){
  printf("%8d %8d %8d %8d %8d %8d \r",tempop,timbreno,pitch,durpattern,repeats,count);
}

/*--------------------beginning improvization algorithms------------------*/

/*---------------------initialization algorithms--------------------------*/
void description(void){
printf("\n\nMANNY0\n");
printf("B15+ ->START  B14+ ->STOP  YT2->LOUDNESS\n");
printf("PANNING REVERSES EACH TIME TIMBRE IS SELECTED\n");
printf("KEYBOARD CONTROL\n");
printf("    TEMPO 1--5  LARGO--PRESTO\n");
printf("    TIMBRE q--t \n");
printf("    PITCH  6,7  DOWN OCTIVE, UP OCTIVE \n");
printf("    REPEATS y,u  DECREASE, INCREASE \n \n");
printf("     TEMPO  TIMBRE   PITCH   DURPATTERN REPEATS  COUNT   \n");
}

void initialization(void){
t_time=nextnotetime=0;
randdur();
yt1=0;
repeats=3;                                  //setup initial configuration
tempop=70;
switchpan();synth.pc(1,60);timbreno=60;
pitch=60;
printline();
jj = 0;
}

void keyboardchar(int kar){
switch(kar){
// tempo
   case '1':tempop=140;printline();break;               //largo
   case '2':tempop=100;printline();break;               //adagio
   case '3':tempop=70;printline();break;                //allegro
   case '4':tempop=50;printline();break;                 //vivace
   case '5':tempop=35;printline();break;                   //presto
// timbre
   case 'q':switchpan();synth.pc(1,50);timbreno=50;printline();break;  //tympany
   case 'w':switchpan();synth.pc(1,57);timbreno=57;printline();break;  //tub bells
   case 'e':switchpan();synth.pc(1,60);timbreno=60;printline();break;  //harp
   case 'r':switchpan();synth.pc(1,46);timbreno=46;printline();break;  //brass
   case 't':switchpan();synth.pc(1,89);timbreno=89;printline();break;  //winter signs
// pitch
   case '6':pitch-=12;if(pitch>TOP)pitch=TOP;printline();break;      //increase
   case '7':pitch+=12;if(pitch<BOTTOM)pitch=BOTTOM;printline();break;//decrease
// repeats
   case 'u':repeats++;printline();break;                           //increase
   case 'y':repeats--;if(repeats<1)repeats=1;printline();break;    //decrease
}//end switch(kar
}//end keyboardchar


/*--------------------main loop algorithms -------------------------------*/
void mainloopalgorithms(void){
if(play){
  durfactor=tempop;
  if(t_time>nextnotetime){
     synth.play(1,keyno,0);
     newdurs=durs[durpattern][durindex++];
     if(newdurs<0){
        nextnotetime=t_time-(durfactor*newdurs);
     }
     else{
        nextnotetime=t_time+(durfactor*newdurs);
        keyno=randpitch();
        synth.play(1,keyno,127);
     }
        if(durs[durpattern][durindex]==0)randdur();
  }
}//end if(play)
}//end mainloopalgorithms()

/*--------------------triggered algorithms--------------------------------*/
void stick1trig(void ){}
void stick2trig(void ){}
void b14plustrig(void ){play=0;}
void b15plustrig(void ){
    play=1;durfactor=50;t_time=nextnotetime=0;description();
}
void b14minusuptrig(void){synth.cont(1,64,0);}
void b14minusdowntrig(void){synth.cont(1,64,127);}
void b15minusuptrig(void){}
void b15minusdowntrig(void){}
void finishup(void){}
/*---------------------------poll responce algorithms----------------------*/



void switchpan(void){
   if(pan<64){pan=127;}
   else{pan=0;}
   synth.cont(1,10,pan);
}


/*---------------------------end improvization algorithms------------------*/



short randpitch(void){
  if(rand()>16384){delta=1;}else{delta=-1;}        //randum up or down interval
  deltapitch=delta*intervalseq[jj];
  pitch=pitch+deltapitch;                                  //pitch of next note
  if(pitch>TOP)   pitch-=2*intervalseq[jj];   //limit max and min pit
  if(pitch<BOTTOM)pitch+=2*intervalseq[jj];
  if(intervalseq[++jj]==-100)jj=0;                      //cycle interval sequence
  synth.cont(1,7,yt2);
  printline();
  return pitch;
}//end randpitch()
void randdur(void){
  if(++count>repeats){
    count=1;
    while(newdurpattern==durpattern)newdurpattern=rand()/4682;
    durpattern=newdurpattern;
    durindex=0;
  }
  durindex=0;
  printline();
}

