//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: 19 December 1997
// Last Modified: Fri Jan 23 00:21:24 GMT-0800 1998
// Filename:      ...sig/code/control/MidiMessage/MidiMessage.h
// Syntax:        C++ 
// $Smake:        cc -g -c %f -I../../../include && rm -f %b.o
//
// Description: A structure for handling MIDI input messages.
//


#ifndef _MIDIMESSAGE_H_INCLUDED
#define _MIDIMESSAGE_H_INCLUDED


#include "sigTypes.h"


class MidiMessage {
   public:
      ulong          time;             // timestamp 
      ulong          data;             // MIDI command and parameters

                     MidiMessage       (void);
                     MidiMessage       (int aCommand, int aP1, int aP2, 
                                          int aTime = 0);
                     MidiMessage       (const MidiMessage& aMessage);
                    ~MidiMessage       ();

      uchar&         command           (void);
      MidiMessage&   operator=         (const MidiMessage& aMessage);
      uchar&         p1                (void);
      uchar&         p2                (void);
      uchar&         p3                (void);
};



#endif  // _MIDIMESSAGE_H_INCLUDED



